<?php
/**
 * Файл для описания класса работы с путями (директориями), 
 * {@link mxl_cfg_path}.
 * @package mxl_cfg
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс
 */
/**
 * Класс для работы с путями (директориями)
 * 
 * @package mxl_cfg
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс, {@link http://www.metarex.ru www.metarex.ru}
 */
class mxl_cfg_path{
	/**
	 * Каталог библиотеки
	 * @var string
	 */
	public static $metaxlib;
	/**
	 * Каталог конфигурации библиотеки
	 * @var string
	 */
	public static $metaxlib_cfg;
	
	/**
	 * разделитель каталогов в путях
	 * @var string
	 */
	public static $separator;
	
	/**
	 * путь к словарю перечислений
	 * @var string
	 */
	public static $core_enums;
	/**
	 * путь к словарю потоков
	 * @var string
	 */
	public static $core_dflows;
	/**
	 * путь к словарю логических БД
	 * @var string
	 */
	public static $core_logicbases;
	
	/**
	 * путь к словарю комбобоксов
	 * @var string
	 */
	public static $dict_comboboxes;
	/**
	 * путь к словарю гридов
	 * @var string
	 */
	public static $dict_grids;
	/**
	 * путь к словарю списков
	 * @var string
	 */
	public static $dict_lists;
	/**
	 * путь к словарю валидации
	 * @var string
	 */
	public static $dict_validators;
	/**
	 * путь к словарю ренереров
	 * @var string
	 */
	public static $dict_renderers;
	
	/**
	 * путь к сниппетам валидации
	 * @var string
	 */
	public static $snippet_validate;
	/**
	 * путь к файлам локализаций
	 * @var string
	 */
	public static $localizations;
	
	/**
	 * Поддиректорий в словарях к исполняемым модулям (сниппетам)
	 * @var string
	 */
	public static $snippet;
	
	/**
	 * Функция читает параметры класса из ассоциированного массива,
	 * сформированного на базе файла конфигурации
	 * @param array $cfg
	 */
	public static function readJSON($cfg){
		mxl_cfg_path::$separator       = $cfg['path']['separator'];

		mxl_cfg_path::$core_enums      = mxl_utils_files::makeAbsolute($cfg['path']['core_enums']);
		mxl_cfg_path::$core_dflows     = mxl_utils_files::makeAbsolute($cfg['path']['core_dflows']);
		mxl_cfg_path::$core_logicbases = mxl_utils_files::makeAbsolute($cfg['path']['core_logicbases']);
		
		mxl_cfg_path::$dict_comboboxes = mxl_utils_files::makeAbsolute($cfg['path']['dict_comboboxes']);
		mxl_cfg_path::$dict_grids      = mxl_utils_files::makeAbsolute($cfg['path']['dict_grids']);
		mxl_cfg_path::$dict_lists      = mxl_utils_files::makeAbsolute($cfg['path']['dict_lists']);
		
		mxl_cfg_path::$dict_validators  = mxl_utils_files::makeAbsolute($cfg['path']['dict_validators']);
		mxl_cfg_path::$dict_renderers   = mxl_utils_files::makeAbsolute($cfg['path']['dict_renderers']);
        
		mxl_cfg_path::$snippet_validate = mxl_utils_files::makeAbsolute($cfg['path']['snippet_validate']);

		mxl_cfg_path::$localizations   = mxl_utils_files::makeAbsolute($cfg['path']['localizations'],
				mxl_cfg_path::$metaxlib);
				
		mxl_cfg_path::$snippet         = $cfg['path']['snippet'];
	}
}
?>