<?php
/**
 * Файл для описания класса визуального компонента комбобокс в стиле поиска, 
 * {@link mxl_widget_combobox}.
 * @package mxl_widget
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс
 */
/**
 * Класс описания виждета комбобокса в стиле поиска.
 * 
 * Пример использования:
 * <code>
 * $WG = new mxl_widget_comboboxseach('countries25', 'countriesWhereLess50');
 * </code>
 * 
 * @package mxl_widget
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс, {@link http://www.metarex.ru www.metarex.ru}
 */
class mxl_widget_comboboxseach extends mxl_widget_combobox{
	/**
	 * Функция для получения ajax кода инициализации и работы компонента.
	 * Генерируемый код делится на несколько частей, которые будут размещены в 
	 * определенном порядке после генерации всего ajax кода.
	 * 
	 * @param string $declarePartCommon - декларативная общая часть, размещается 1-ой.
	 * @param string $declarePartPers - декларативная часть для компонента, размещается 2-ой
	 * @param string $runPartFirst - часть которая будет выполнена 1-ой, размещается 3-ей, 
	 * 		но 1-ой в части выполнения startAutoGenScript
	 * @param string $runPartLast - часть которая будет выполнена последней, размещается 4-ей, 
	 * 		но 2-ой в части выполнения startAutoGenScript
	 * @param string $funcsAfterInit - функции которые будут выполнены поле инициализации,
	 * 		размещается 4-ой.
	 * @param boolean $append_SID - параметр (костыль) определяющий передавать ли $_SID через
	 * 		baseParam и необходимо ли определять функцию для получения _SID
	 */
	public function getJSCode(&$declarePartCommon, &$declarePartPers, 
			&$runPartFirst, &$runPartLast, &$funcsAfterInit, $append_SID = false){
		global  $_SID;
		
		$nameWG   = $this->getName();
		$nameCFG  = $this->getComboName();
		$CBX	  = $this->getLinkCFG();

		$url      = $this->getUrlRequestPhpFile();
		
		$nm1 = 'store_cbx_'.$nameWG;
		$nm2 = 'cbx_'.$nameWG;
		
		$x = ''; 
		$y = '';
		
		$bparam = '{comboName: "'.$nameCFG;
		if ($append_SID)
			$bparam .= '", sid:"'. $_SID;
		$bparam .= '"}';

		$y .= 'var '. $nm1.';'.NL;
		$x .= mxl_widget_extjs::get_combo_data_Store($nm1, $CBX, $bparam, $url);
		
		$y .= 'var '. $nm2.';'.NL;
		$x .= mxl_widget_extjs::get_form_ComboBox_Seach($nm2, $nm1, $CBX, 
				$this->getHiddenName());

		$declarePartPers = $y;
		$runPartFirst    = $x;
	} 

	/**
	 * Функция проверки типа обработчика события визуального компонента.
	 * В случае удачной проверки возвращает true;
	 * @param string $type - проверяемый тип
	 * @return boolean
	 */
	public function checkEventHandlerType($type){
		return  false;		
	}
}
?>