<?php
/**
 * Файл для описания класса работы с ExtJS, {@link mxl_widget_extjs}.
 * @package mxl_widget
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс
 */
if (!defined('NL'))
	define('NL', "\n");
	
/**
 * Класс для работы с ExtJS.
 * @package mxl_widget
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс, {@link http://www.metarex.ru www.metarex.ru}
 */
class mxl_widget_extjs{
/*
 * ============================================================================
 * =====================  ФУНКЦИИ EXTJS ОБЩЕГО НАЗНАЧЕНИЯ ===================== 
 * ============================================================================
 */	
	
	/**
	 * Метод получения JS кода текстового поля.
	 * @param string $varName - имя переменной
	 * @param int $dataLength - длинна
	 * @param string $maskRe - маска ввода
	 * @return string
	 */
	public static function getNew_form_TextField($varName, $dataLength, 
			$maskRe, $listeners = ''){
		$str = 'var '.$varName.' = new Ext.form.TextField({maxLength:'.$dataLength;
		if ($maskRe != '')
			$str .= ', maskRe:'.$maskRe;
		if (!is_null($listeners) && count($listeners) > 0) {
			$buf = '';
			foreach ($listeners as $k => $v) {
				$buf .= $buf == '' ? '' : ', ';
				$buf .= $k.':'.$v;
			}
			$str .= ', listeners:{'.$buf.'}';
		}
		$str .= '});';
		return $str;
	}
	
	/**
	 * Метод получения JS кода числового поля.
	 * @param $varName - имя переменной
	 * @return string
	 */
	public static function getNew_form_NumberField($varName, $decimalPrecision, $listeners = ''){
		$str  = 'var '.$varName.' = new Ext.form.NumberField({'.NL;
		$str .= '  decimalPrecision: '.$decimalPrecision;
		if (!is_null($listeners) && count($listeners) > 0) {
			$buf = '';
			foreach ($listeners as $k => $v) {
				$buf .= $buf == '' ? '' : ', ';
				$buf .= $k.':'.$v;
			}
			$str .= ','.NL.'  listeners:{'.$buf.'}'.NL;
		}
		$str .= '});';
		return $str;
	} 
	
	/**
	 * Метод для получения JS кода поля даты.
	 * @param string $varName - имя переменной
	 * @param string $format - формат отображения
	 * @param string $autoWidth - авторегилируемая ширина
	 * @param string $width - ширина
	 * @param string $allowBlank - 
	 * @param string $anchor - 
	 * @return string
	 */
	public static function getNew_form_DateField($varName, $format = 'd/m/Y', 
			$autoWidth = '', $width = '', $allowBlank = '', $anchor = '', 
			$listeners = ''){
		$str = 'var '.$varName.' = new Ext.form.DateField({format: "'.$format.'"';
		if ($autoWidth != '') 
			$str .= ', autoWidth: '.$autoWidth;
		if ($width != '') 
			$str .= ', width: '.$width;
		if ($allowBlank != '') 
			$str .= ', allowBlank: '.$allowBlank;
		if ($anchor != '') 
			$str .= ', anchor: '.$anchor;
		if (!is_null($listeners) && count($listeners) > 0) {
			$buf = '';
			foreach ($listeners as $k => $v) {
				$buf .= $buf == '' ? '' : ', ';
				$buf .= $k.':'.$v;
			}
			$str .= ', listeners:{'.$buf.'}';
		}
		$str .= '});';
		return $str;
	}
	
	/**
	 * Метод для получения JS ккод поля времени.
	 * @param string $varName - имя переменной
	 * @param string $format - формат отображения
	 * @param string $autoWidth - авторегилируемая ширина
	 * @param string $width - ширина
	 * @param string $allowBlank - 
	 * @param string $anchor - 
	 * @return string
	 */
	public static function getNew_form_TimeField($varName, $format = 'H:i', 
			$autoWidth = '', $width = '', $allowBlank = '', $anchor = '', 
			$listeners = ''){
		$str = 'var '.$varName.' = new Ext.form.TimeField({format: "'.$format.'"';
		if ($autoWidth != '') 
			$str .= ', autoWidth: '.$autoWidth;
		if ($width != '') 
			$str .= ', width: '.$width;
		if ($allowBlank != '') 
			$str .= ', allowBlank: '.$allowBlank;
		if ($anchor != '') 
			$str .= ', anchor: '.$anchor;
		if (!is_null($listeners) && count($listeners) > 0) {
			$buf = '';
			foreach ($listeners as $k => $v) {
				$buf .= $buf == '' ? '' : ', ';
				$buf .= $k.':'.$v;
			}
			$str .= ', listeners:{'.$buf.'}';
		}
		$str .= '});';
		return $str;
	}
	
/*
 * ============================================================================
 * ====================  ФУНКЦИИ EXTJS ДЛЯ ПОДДЕРЖКИ ГРИДА ==================== 
 * ============================================================================
 */	
	/**
	 * Метод для получения JS кода процедуры вставки строки в грид.
	 * @param string $funcNamePref - префикс к имени функции
	 * @param string $dataRecordName - имя типа строки
	 * @param array $defaultData - ассоциированный масив значений по умолчанию
	 * @return string
	 */
	public static function getFuncText_dbgAppendRow($funcNamePref, $dataRecordName,
			$defaultData = ''){
		$x =     'function dbgAppendRow_'.$funcNamePref.'(event, toolEl, panel) {'.NL;
		if (!$defaultData)
			$x .= '  var newRecord = new '.$dataRecordName.'({});'.NL;
		else {
			$x .= '  var defData = {';
			$nas = true;
			foreach ($defaultData as $key => $value){
				$x .= (!$nas ? ',' : '').NL.'    '.$key.': \''.addcslashes($value, "\000\n\r\\'\"\032").'\'';
				$nas = false;
			}
			$x .= NL.'  };'.NL;
			$x .= '  var recId = panel.getStore().getCount();'.NL;
			$x .= '  var newRecord = new '.$dataRecordName.'(defData, recId++);'.NL;
		}
				
		$x .=	// вариант для вставки записи после выделенной строки		
				 '  var sel = panel.getSelectionModel().getSelected();'.NL
				.'  var selIndex = 1;'.NL
				.'  if (sel) '.NL
				.'    selIndex += panel.getStore().indexOf(sel)'.NL
				.'  else '.NL
				.'    selIndex = panel.getStore().getCount();'.NL
				.'  panel.getStore().insert(selIndex, newRecord);'.NL
				.'  panel.getSelectionModel().selectRow(selIndex);'.NL
				.'  panel.getView().focusRow(selIndex);'.NL
				
				//вариант для вставки записи в начало грида
				//.'  panel.getStore().insert(0, new '.$dataRecordName.'({}));'.NL
				//.'  panel.getView().scrollToTop(); '.NL
				//.'  panel.getSelectionModel().selectFirstRow();'.NL
				.'}'.NL;
		return $x;
	} 
	
	/**
	 * Возвращает текст функции для обработчика кнопки удалить. 
	 * 
	 * @param string $funcNamePref - префикс функции
	 * @param string $url - URL адрес посылки запроса
	 * @param string $paramsExt -расширение параметров передачи через url, 
	 * 		например для сида: $paramsExt=',sid:"'. $_SID.'"';
	 * @param string $successExt - код расширения в случе успеха. Код на JS, в конце 
	 * 		каждой строки ';'
	 * @return string
	 */
	public static function getFuncText_dbgDeleteRow($funcNamePref, $url, 
			$paramsExt, $gridName, $successExt = ''){
		$titleDel    = mxl_cfg_messages::$widgets_dbgrid_delete_before_title;
		$unableToDel = mxl_cfg_messages::$widgets_dbgrid_delete_unable;
		$mesDel      = mxl_cfg_messages::$widgets_dbgrid_delete_before_mess;
		if (strpos($mesDel, '#VTINS') !== false)
			$mesDel = str_replace('#VTINS', '" + panel.title + "', $mesDel);
			
		$sss =   'function dbgDeleteRow'.$funcNamePref.'(event, toolEl, panel){'.NL
        		.' var sm = panel.getSelectionModel();'.NL
        		.' var sel = sm.getSelected();'.NL
        		.' if (sm.hasSelection()){'.NL
        		.'    Ext.Msg.show({'.NL
        		.'    title: "'.$titleDel.'",'.NL
        		.'    buttons: Ext.MessageBox.YESNO,'.NL
        		.'    msg:"'.$mesDel.'", '.NL
        		.'    fn: function(btn){'.NL
        		.'         if (btn == "yes"){'.NL
        		.'          if (sel.get(panel.store.baseParams["pkey"]) > 0)  {'.NL
        		.'             var conn = new Ext.data.Connection();'.NL
        		.'             conn.request({'.NL
        		.'             url: "'.$url.'",'.NL
        		.'             params: {'.NL
        		.'             action: "delete",'.NL
        		.'             gridName: panel.getStore().baseParams["gridName"],'.NL
        		.'             params: panel.getStore().baseParams["params"],'.NL
        		.'             key: sel.get(panel.getStore().baseParams["pkey"])'.NL
        		.($paramsExt ? '            ' .$paramsExt.NL : '')
        		.'               },'.NL
        		.'             success: function(resp,opt) {'.NL
        		.'               var fail = Ext.util.JSON.decode(resp.responseText).failure;'.NL
        		.'               if (fail) {'.NL
        		.'                 mxl_showErrorByResponseText(resp.responseText, "'
        								.$unableToDel.'");'.NL
        		.'                } else {'.NL
        		. $successExt.NL
        		.'                 panel.getStore().remove(sel);'.NL
				.'                 dbgGridUpdateInf_'.$gridName.'('.$gridName.');'.NL        		
        		.'               }'.NL
        		.'              },'.NL
        		.'             failure: function(resp,opt) {'.NL
        		.'               Ext.Msg.alert("'.mxl_cfg_messages::$types_error
        								.'", "'.$unableToDel.'");'.NL
        		.'              }'.NL
        		.'             });'.NL
        		.'            } else {'.NL
        		.'               panel.getStore().remove(sel);'.NL
				.'               dbgGridUpdateInf_'.$gridName.'('.$gridName.');'.NL        		
        		.'            }'.NL
        		.'          }'.NL
        		.'        }'.NL
        		.'    })'.NL
        		.' } else {'.NL
        		.'     Ext.MessageBox.alert("'.mxl_cfg_messages::$types_message
        				.'", "'.mxl_cfg_messages::$widgets_dbgrid__no_row_selected.'" )'.NL
        		.' };'.NL
        		.'};';
        return $sss;
	}
	
	/**
	 * Функция возращает текст функции для обработчика кнопки сохранить. Для 
	 * режима работы грида: сохранение только по одной строке.
	 * 
	 * @param string $funcNamePref - префикс функции
	 * @param string $url - url адрес для посылки запроса
	 * @param string $paramsExt -расширение параметров передачи через url, 
	 * 		например для сида: $paramsExt=',sid:"'. $_SID.'"';
	 * @param string $successExt - код расширения в случе успеха. Код на JS, в
	 * 		конце каждой строки ';'
	 * @return string
	 */
	public static function getFuncText_dbgSaveRow($funcNamePref, 
			$url, $paramsExt, $successExt){
		$unableToSave = mxl_cfg_messages::$widgets_dbgrid_save_row_unable;
		$sss = 'function dbgSaveRow'.$funcNamePref.'(event, toolEl, panel) {'.NL
        		.' var sm = panel.getSelectionModel();'.NL
        		.' var sel = sm.getSelected();'.NL
        		.' if (sm.hasSelection()){'.NL
        		.'  var encoded_data = Ext.encode(sel.data)'.NL
        		.'  if (encoded_data.length > 2) {'.NL
        		.'      var conn = new Ext.data.Connection();'.NL
        		.'      conn.request({'.NL
        		.'      url: "'.$url.'",'.NL
        		.'      params: {'.NL
        		.'        action: "saverow",'.NL
        		.'        gridName: panel.getStore().baseParams["gridName"],'.NL
        		.'        params: panel.getStore().baseParams["params"],'.NL
        		.'        key: sel.get(panel.getStore().baseParams["pkey"]),'.NL
        		.'        data: encoded_data'.NL
        		.($paramsExt ? '            ' .$paramsExt.NL : '')
        		.'      },'.NL
        		.'      success: function(resp,opt) {'.NL
        		.'         var insert_id = Ext.util.JSON.decode(resp.responseText).record_id;'.NL
        		.'         var fail = Ext.util.JSON.decode(resp.responseText).failure;'.NL
        		.'         if (fail) {'.NL
        		.'           mxl_showErrorByResponseText(resp.responseText, "'.$unableToSave.'");'.NL
        		.'         } else {'.NL
        		. $successExt.NL
        		.'            if (insert_id > 0)'.NL
        		.'              sel.set(panel.getStore().baseParams["pkey"], insert_id);'.NL
        		.'            sel.commit();'.NL
        		.'         }'.NL
        		.'       },'.NL
        		.'       failure: function(resp,opt) {'.NL
        		.'         Ext.Msg.alert("'.mxl_cfg_messages::$types_error.'", "'.$unableToSave.'");'.NL
        		.'       }'.NL
        		.'      });'.NL
        		.'   };'.NL
        		.' };'.NL
        		.'}';
        return $sss;
	}
	
	/**
	 * Функция возращает текст функции для обработчика кнопки сохранить. Для 
	 * режима работы грида: сохранение всех измененных строк при помощи одного 
	 * запроса для каждой измененной строки.
	 * 
	 * ВНИМАНИЕ: режим не доделан и не инициализирован.
	 * Не долелан:  в обработчике update хранилища грида, необходимо дописать 
	 * кусок посылки запроса на строки итогов в шапкею
	 * Не инициализирован: в режим формирования нельзя перейти, так как нет
	 * свойства переключения.  
	 * 
	 * @param string $funcNamePref
	 * @param string $url
	 * @param strnng $paramsExt -расширение параметров передачи через url, 
	 * 		например для сида: $paramsExt=',sid:"'. $_SID.'"';
	 * @param strign $successExt - код расширения в случе успеха. Код на JS, 
	 * 		в конце каждой строки ';'
	 * @return string
	 */
	public static function getFuncText_dbgSaveRow_ManyRows_single($funcNamePref, 
			$url, $paramsExt, $successExt){
		$unableToSave = mxl_cfg_messages::$widgets_dbgrid_save_rows_unable;
		$sss =   'function dbgSaveRow'.$funcNamePref.'(event, toolEl, panel) {'.NL
        		.'  var sm = panel.getSelectionModel();'.NL
        		.'  var modRec = sm.grid.store.getModifiedRecords();'.NL
        		.'  for ( var i = 0; i < modRec.length; i++) {'.NL
        		.'    var curRec = modRec[i];'.NL
        		.'    var encoded_data = Ext.encode(curRec.data);'.NL
        		.'    if (encoded_data.length > 2) {'.NL
        		.'      var conn = new Ext.data.Connection();'.NL
        		.'      conn.request({'.NL
        		.'      url: "'.$url.'",'.NL
        		.'      params: {'.NL
        		.'        action: "insert",'.NL
        		.'        gridName: panel.getStore().baseParams["gridName"],'.NL
        		.'        params: panel.getStore().baseParams["params"],'.NL
        		.'        key: curRec.get(panel.getStore().baseParams["pkey"]),'.NL
        		.'        record_id: curRec.id,'.NL
        		.'        data: encoded_data'.NL
        		.($paramsExt ? '            ' .$paramsExt.NL : '')
        		.'      },'.NL
        		.'      success: function(resp,opt) {'.NL
        		.'        var insert_id = Ext.util.JSON.decode(resp.responseText).insert_id;'.NL
        		.'        var fail = Ext.util.JSON.decode(resp.responseText).failure;'.NL
        		.'        if (fail) {'.NL
        		.'          mxl_showErrorByResponseText(resp.responseText, "'.$unableToSave.'");'.NL
        		.'        } else {'.NL
        		. $successExt.NL
              	.'           var record_id = Ext.util.JSON.decode(resp.responseText).record_id;'.NL
              	.'           var recordToCh = panel.getSelectionModel().grid.store.getById(record_id);'.NL
              	.'           if (insert_id > 0)'.NL
              	.'             recordToCh.set(panel.getStore().baseParams["pkey"], insert_id);'.NL
              	.'           recordToCh.commit();'.NL
              	.'         }'.NL
              	.'      },'.NL
              	.'      failure: function(resp,opt) {'.NL
              	.'        Ext.Msg.alert("'.mxl_cfg_messages::$types_error.'", "'.$unableToSave.'");'.NL
              	.'      }'.NL
              	.'      });'.NL
              	.'    };'.NL
              	.'  };'.NL
              	.'}'.NL;
        return $sss;
        
	}
	
	/**
	 * Функция возращает текст функции для обработчика кнопки сохранить. Для 
	 * режима работы грида: сохранение всех измененных строк при помощи одного 
	 * запроса к серверной части.
	 * 
	 * @param string $funcNamePref - префикс функции
	 * @param string $url - URL адресс для посылки запроса для изменения данных
	 * 		(\request\getbdgrid.php)
	 * @param string $paramsExt -расширение параметров передачи через url, 
	 * 		например для сида: $paramsExt=',sid:"'. $_SID.'"';
	 * @param string $successExt - код расширения в случе успеха. Код на JS, 
	 * 		в конце	каждой строки ';'
	 * @return string
	 */
	public static function getFuncText_dbgSaveRow_ManyRows_array($funcNamePref, 
			$url, $paramsExt, $successExt){
		$unableToSave = mxl_cfg_messages::$widgets_dbgrid_save_rows_unable;
		$sss =   'function dbgSaveRow'.$funcNamePref.'(event, toolEl, panel) {'.NL
				.'  var sm = panel.getSelectionModel();'.NL
				.'  var modRec = sm.grid.store.getModifiedRecords();'.NL
				.'  if (modRec.length < 1)'.NL
				.'	  return;'.NL.NL
				.'  var pKey = panel.getStore().baseParams["pkey"];'.NL
				.'  var keys       = new Array();'.NL
				.'  var recordIds  = new Array();'.NL
				.'  var rowsTS = new Array();'.NL
				.'  for ( var i = 0; i < modRec.length; i++) {'.NL
				.'    var curRec   = modRec[i];'.NL.NL
				.'    rowsTS[i]    = curRec.data;'.NL
				.'    recordIds[i] = curRec.id;'.NL
				.'    key1 = curRec.get(pKey);'.NL
				.'    keys[i]      = (key1 ? key1 : "");'.NL
				.'  }'.NL
				.'  var keysData   = Ext.encode(keys);'.NL
				.'  var rowsTSData = Ext.encode(rowsTS);'.NL.NL
  				.'  var conn = new Ext.data.Connection();'
				.'  conn.request({'
				.'    url: "'.$url.'",'.NL
				.'    params: {'.NL
				.'      action: "saverows",'.NL
				.'      gridName: panel.getStore().baseParams["gridName"],'.NL
				.'      params: panel.getStore().baseParams["params"],'.NL
				.'      keys: keysData,'.NL
				.'      rowsData: rowsTSData'.NL
				.($paramsExt ? '      ' .$paramsExt.NL : '')
				.'    },'.NL
				.'    success: function(resp,opt) {'.NL
				.'      var fail = Ext.util.JSON.decode(resp.responseText).failure;'.NL
				.'      if (fail) {'.NL
        		.'        mxl_showErrorByResponseText(resp.responseText, "'
        								.$unableToSave.'");'.NL
				.'      } else {'.NL
        		. $successExt.NL
				.'        var row_is_saved = Ext.util.JSON.decode(resp.responseText).row_is_saved;'.NL
				.'        var insert_ids   = Ext.util.JSON.decode(resp.responseText).insert_ids;'.NL
        		.'        for(var i = 0; i < row_is_saved.length; i++){'.NL
				.'        	if (row_is_saved[i]){'.NL
				.'        		var insert_id = insert_ids[i];'.NL
				.'        		var recordToCh = sm.grid.store.getById(recordIds[i]);'.NL
				.'        		if (insert_id > 0)'.NL
				.'        			recordToCh.set(pKey, insert_id);'.NL
				.'        		recordToCh.commit();'.NL
				.'        	}else'.NL
				.'        		Ext.Msg.alert("'.mxl_cfg_messages::$types_error
        								.'", "'.$unableToSave.'");'.NL
				.'        }'.NL
				.'      }'.NL
				.'    },'.NL
				.'    failure: function(resp,opt) {'.NL
				.'      Ext.Msg.alert("'.mxl_cfg_messages::$types_error.'", "'.$unableToSave.'");'.NL
				.'    }'.NL
				.'  });'.NL
				.'}'.NL;
		return $sss;
	}
	
	/**
	 * Возвращает JS код для функции обработчика события afteredit которая строится для EditorGridPanel
	 * 
	 * В обработчик встраивается код по посылке запроса и обновлению "связанных 
	 * полей комбо"
	 * 
	 * Если грид находится в режиме "множественного сохранения строк" то в обработчик
	 * встраивается код, который выводит в шапку грида текст о кол-ве несохраненных 
	 * строк.
	 *  
	 * @param string $gridName - имя грида для которого строится обработчик
	 * @param mxl_dict_dbgrid $DBG - описание грида
     * @param string $gridUrl - url на который отправляются запросы к гриду
	 * @return string
	 */
	public static function getFuncText_grdOnAfterEdit($gridName, mxl_dict_dbgrid $DBG, $gridUrl, $append_SID = false){
		global $_SID;
		$unableToUpdate = mxl_cfg_messages::$widgets_dbgrid_update__linkFields_unable;
		$x11 = '';
		$x = 'function grdOnAfterEdit_'.$gridName.'(e){'.NL
            .'  var rec = e.record;'.NL;
        
		foreach ($DBG->getListFields() as $FI){
			if ($FI->getDataType() != 'string' || !$FI->getCfgComboName() 
					|| $FI->getAttribs()->isEnum())
				continue;

			$edit_name = 'edit_'.$DBG->getName().'_'.$FI->getName();
			$cbxW      = new mxl_widget_combobox($edit_name, $FI->getCfgComboName(), 
					'', new mxl_core_params());
			$cbx       = $cbxW->getLinkCFG();
			
			if ($FI->getCfgComboType() == 1) {
				$x .=	'  if (e.field == "'.$FI->getName().'") {'.NL.
						'    var val = rec.get("'.$cbx->getValueField().'");'.NL.
						'    var returnValue = "??????????????";'.NL.
						'    // get returnValue from comboBox-store'.NL.
						'    var idx = '.'store_dbgcbx_'.$FI->getName().'.findBy('.
								'function(rec){'.NL.
						'      if (rec.get("'.$cbx->getValueField().'") == val){'.NL.
						'        returnValue = rec.get("'.$cbx->getDisplayField().'");'.NL.
						'        return true;'.NL.
						'      }'.NL.
						'    });'.NL.
						'    var key_save = rec.get("'.$cbx->getValueField().'");'.NL.
						'    rec.beginEdit();'.NL.
						'    rec.set("'.$cbx->getValueField().'",  0);'.NL.
						'    rec.set("'.$cbx->getValueField().'",  key_save);'.NL.
						'    rec.set("'.$FI->getName().'",  returnValue);'.NL.
						'    rec.endEdit();'.NL.
						'  }'.NL;
			} elseif ($FI->getCfgComboType() == 2) {
				if (!$FI->getRelSyn()) 
					continue;
				
				$flist = $DBG->getRelListFieldsByRelSyn($FI->getRelSyn());
										
				if (!sizeof($flist)) 
					continue;
				
				$mod1 = '';
				$TAB  = '            ';
				foreach ($flist as $f)
					$mod1 .= 'rec.set("'.$f->getName().'", row.'.$f->getRelField().');'
							.NL.$TAB;

				$mod1 = $TAB.
						'rec.beginEdit();'.NL.$TAB.
						$mod1.
						'rec.set("'.$FI->getRelIdFieldFromRel().'",  0);'.NL.$TAB.
						'rec.set("'.$FI->getRelIdFieldFromRel().'",  field);'.NL.$TAB.
						'rec.endEdit();'.NL;
				$x .=   '  if (e.field == "'.$FI->getName().'") {'.NL.
						'    var sm = '.$gridName.'.getSelectionModel();'.NL.
						'    var conn = new Ext.data.Connection();'.NL.
						'    var field = rec.get("'.$FI->getRelIdFieldFromRel().'");'.NL.
						'      conn.request({'.NL.
						'      url: "'.$gridUrl.'",'.NL.
						'      params: {'.NL.
						'        action: "update_link_fields",'.NL.
						'        gridName: '.$gridName.'.getStore().baseParams["gridName"],'.NL.
						'        params: '.$gridName.'.getStore().baseParams["params"],'.NL.
						'        fieldName: "'.$FI->getName().'",'.NL.
						'        key: "'.$cbx->getValueField().'",'.NL.
						'        value: field'.
						($append_SID ? ','.NL.$TAB.'sid:"'. $_SID.'"' : '').NL.
						'      },'.NL.
						'      success: function(resp,opt) {'.NL.
						'        var row  = Ext.util.JSON.decode(resp.responseText).fields;'.NL.
						'        var fail = Ext.util.JSON.decode(resp.responseText).failure;'.NL.
						'        if (fail) {'.NL.
        				'          mxl_showErrorByResponseText(resp.responseText, "'
        								.$unableToUpdate.'");'.NL.
						'        } else {'.NL.
						'          if (row) {'.NL.
								     $mod1.
						'          }'.NL.
						'        }'.NL.
						'      },'.NL.
						'      failure: function(resp,opt) {'.NL.
						'        Ext.Msg.alert("'.mxl_cfg_messages::$types_error
        								.'", "'.$unableToUpdate.'");'.NL.
						'      }'.NL.
						'    });'.NL.
						'  }'.NL;
			}
		}
		$x .= '};'.NL;	
		return $x11.$x;
	}
    
    /**
	 * Возвращает JS код для функции обработчика события updatre которая строится для store грида
	 * 
	 * @param string $gridName - имя грида для которого строится обработчик
	 * @return string
	 */
	public static function getFuncText_dbgOnUpdate($gridName) {
		$x =  'function strgOnUpdate_store_'.$gridName.'(e){'.NL
            . '  dbgGridUpdateInf_'.$gridName.'('.$gridName.');'.NL
            . '};'.NL;	
		return $x;
	}
	
	/**
	 * Возвращает JS код функции для обновления информации по гриду
	 * @param string $gridName
	 * @param mxl_dict_dbgrid $DBG
	 * @return string
	 */
	public static function getFuncText_dbgUpdateGridInformation($gridName, 
			mxl_dict_dbgrid $DBG){
		$x = 'function dbgGridUpdateInf_'.$gridName.'(grid){'.NL;
		
		if ($DBG->isManyRowsSaveMode()){
			$mess = mxl_cfg_messages::$widgets_dbgrid_rows_not_saved;
			if (strpos($mess, '#VTINS') !== false)
				$mess = str_replace('#VTINS', '<font color=red>" '.NL
					.'      + notSavedRows + "</font>', $mess);
				
			$x .=    '  var el = Ext.get("'.$gridName.'_notsavedrows").dom;'.NL
					.'  var nsr_str = "";'.NL
					.'  var notSavedRows = grid.getStore().getModifiedRecords().length;'.NL
					.'  if (notSavedRows > 0){'.NL
					.'    nsr_str = " '.$mess.' ";'.NL
					.'  }'.NL
					.'  if (el)'.NL
					.'    el.innerHTML = nsr_str;'.NL;
		}
		$x .= '};'.NL;	
		return $x;
	}
	
	/**
	 * Фозвращает текст функции для кнопки обновить.
	 * 
	 * Функция отменяет все именения в гриде, вызывает посылку запроса на 
	 * получение данных, вызывает обработчик update для грида (для сброса 
	 * информации о кол-ве несохраненных строк в гриде)
	 * 
	 * @param string $funcNamePref - префикс для имени функции
	 * @param string $gridStorageName - имя хранилища даннх грида
	 * @return string
	 */		
	public static function getFuncText_dbgRefreshData($funcNamePref, $gridStorageName){
		return   'function dbgRefreshData'.$funcNamePref.'(event, toolEl, panel){'.NL
				.'  panel.getStore().rejectChanges();'.NL
				.'  panel.getStore().reload();'.NL
				.'  strgOnUpdate_'.$gridStorageName.'(panel.getStore());'.NL
				.'};';
	} 
	
	/**
	 * Возвращает текст функции для события перед выбором строки.
	 * 
	 * Функция проверяет наличие несохраненных строк в гриде и если они есть
	 * то запрещает переход на другую строку. 
	 * 
	 * Актуально для режима работы грида isManyRowsSave() == false, т.е. 
	 * построчное сохранение данных.
	 * 
	 * @param string $funcNamePref - префикс функции
	 * @return string
	 */
	public static function getFuncText_dbgBeforeRowSelect($funcNamePref){
		$notSR = mxl_cfg_messages::$widgets_dbgrid_select_before__not_saved_data;
		return   'function dbgBeforeRowSelect'.$funcNamePref.'(sm, rowIndex, '
						.'keepExisting, record) {'.NL
				.'  var sel = sm.getSelected();'.NL
				.'  if (sm.grid.store.getModifiedRecords().length > 0 ) {'.NL
				.'//  if (sel && sel.getChanges()!= null){ '.NL
				.'    Ext.Msg.alert("'.mxl_cfg_messages::$types_attention
									.'", "'.$notSR.'");'.NL
				.'    return false;'.NL
				.'  }'.NL
				.'};';
	}
	
	/** 
	 * Метод возвращает код JS для создания хранилища данных грида.
	 * @param string $varName - имя грида
	 * @param mxl_dict_dbgrid $DBG - модель грида
	 * @param string $baseParams - текст JS определяющий базовые параметры
	 * @param string $url - текст JS определяющий URL адрес запроса
	 * @param boolean $autoload - определяет будет ли загрузка происходить 
	 * 		автоматически или вручную 
	 * @return string
	 */
	public static function get_dbg_data_Store($varName, mxl_dict_dbgrid $DBG,
			$baseParams, $url, $autoload = true){
		$x = $varName.' = new Ext.data.Store({'.NL
				. ($DBG->isPagingMode() ? '  remoteSort: true,'.NL : '')	
				. '  reader: new Ext.data.JsonReader({'.NL
				. '  id:"'.$varName.'",'.NL
				. '  root: "rows"'
				. ($DBG->isPagingMode() ? ','.NL.'  totalProperty: "total"'.NL : NL)
				. '  },'.NL
				. '  ['.NL;

		foreach ($DBG->getListFields() as $FI){
			if ($FI->getDataType() == 'edatetime'){
				$x .='  {name: "'.$FI->getName().'_date",  type: "date",'
						.'mapping:"'.$FI->getName().'_date"},'.NL;
				$x .='  {name: "'.$FI->getName().'_time",  type: "string",'
						.'mapping:"'.$FI->getName().'_time"},'.NL;
			}else{
				$x .='  {name: "'.$FI->getName().'",  type: "'.$FI->getDataType()
						.'", mapping:"'.$FI->getName().'"},'.NL;
			}        				
        }
		$x = substr($x, 0, strlen($x) - 2).NL;

		$x .='  ]),'.NL
				. '  pruneModifiedRecords: true,'
				. '  proxy: new Ext.data.HttpProxy({'.NL
				. '  url: "'.$url.'",'.NL
				. '  method: "POST"'.NL
				. '  }),'.NL
				. '  baseParams:'.$baseParams
				. ($DBG->isReadOnly()? '': ','.NL. '  listeners: {update : strgOnUpdate_'.$varName.'}'.NL)
				. '  });'.NL;

		if ($autoload){
            if ($DBG->isPagingMode()){
                $x .= $varName.'.baseParams[\'start\'] = '.$DBG->getPageStart().';'.NL;
                $x .= $varName.'.baseParams[\'limit\'] = '.$DBG->getPageSize().';'.NL;
            }
		}
        //$x .= ' mxl_check_and_load_grid_store('.$varName.');'.NL;
		
		return $x;
	}
	
	/**
	 * Функция проверяет наличие макроса #VTINS в строке, и если он отсутствует
	 * то добавляет его в начало строки.
	 * После чего заменяет макрос #VTINS на значение переменной V.
	 * Этот метод является составной частью процедур по работе с итогами в футере
	 * грида.
	 * @param string $str - проверяемая строка
	 * @return string
	 */
	private static function addVTINSifNeedAndReplace($str){
		if (strpos($str, '#VTINS') === false){
			$str = '#VTINS'.$str; 
		}
		return str_replace('#VTINS', '&#160;" + v + "&#160;', $str);	
	}
	
	/**
	 * Функция возвращает JS выражение для рендера итогов в футере. 
	 * Строится по правилам для заголовка итогов в футере.
	 * 
	 * @param string $caption
	 * @return string
	 */
	private static function getGridFooterTotals_sumRenderer_returnText(
			$caption){
		$x = '';
		
		$NVAL = '';
		$defT = '';
		$valT = array();
		
		$list = mxl_utils_str::exclude_repetitions($caption, '|');
		foreach ($list as $item){
			if (strpos($item, '#NVAL') !== false)
				$NVAL = '"'.mxl_utils_str::getNWord($item, 1, '=').'"';
			elseif (strpos($item, '=') !== false)
				$valT[] = $item;
			else
				$defT = '"'.mxl_widget_extjs::addVTINSifNeedAndReplace($item).'"';
		}

		foreach ($valT as $vti){
			if ($x != '') 
				$x .= ' else ';
			$val  = mxl_utils_str::getNWord($vti, 0, '=');
			$text = ' "'.mxl_utils_str::getNWord($vti, 1, '=').'" ';
			$text = mxl_widget_extjs::addVTINSifNeedAndReplace($text);
			$x .= 'if (v == '. $val .') { return'.$text.';}'.NL;
		}
		if ($NVAL)
			$x = 'if (!v) {return '.$NVAL.';'.NL.'} else '.$x;

		if ($defT == '')
			$defT = '""';
		if ($x != '')
			$x .= ' else ';
		
		$x .= ' return '.$defT.';'.NL;
		return $x;
	}
	
	/**
	 * Функция возвращает JS выражение рендеров итогов в футере, для грида. 
	 * @return string
	 * @param $gridName - имя грида 
	 * @param mxl_dict_dbgrid $DBG - модель грида
	 */
	public static function get_dbg_gridFooterTotals_sumRenderers($gridName,
			mxl_dict_dbgrid $DBG){
		$x = '';
		foreach ($DBG->getListTotalsFooter() as $TFI){
			if ($TFI->getHint() != '' || $TFI->getCaption() != ''){
				$x .= 'function sumRenderer_'.$gridName.'_'.$TFI->getName()
						.'(v, params, data){'.NL;
				
				if ($TFI->getHint())
				 	$x .= '  params.attr = \'ext:qtip="'.$TFI->getHint().'"\';'.NL;

				
				if ($TFI->getCaption())
					$x .= mxl_widget_extjs::getGridFooterTotals_sumRenderer_returnText(
							$TFI->getCaption());
				else
				 	$x .= '  return v;'.NL;
				 	
				$x .= '};'.NL;
			}
		}
		return $x;
	}
	
	/**
	 * Метод возвращает JS код инициализации панели грида.
	 * @param mxl_widget_dbgrid $WDBG - Виджет грида
	 * @param string $varName - имя грида
	 * @param string $storeName - имя хранилища грида
	 * @param mxl_dict_dbgrid $DBG - модель грида
	 * @param boolean $add_combo_renderer - добавлять рендер для комбо
	 * @param boolean $add_date_renderer - добалять комбо для даты
	 * @return string 
	 */
	public static function get_dbg_grid_GridPane( mxl_widget_dbgrid $WDBG,
			$varName, $storeName, mxl_dict_dbgrid $DBG, $url, 
			$add_combo_renderer = true,	$add_date_renderer  = true){
		$befX = '';
		$checkColumns = '';
		$nameWidget   = $WDBG->getName();
				
		if ($DBG->isReadOnly())
			$x = $varName.' = new Ext.grid.GridPanel({';
		else
			$x = $varName.' = new Ext.grid.EditorGridPanel({';
			
		$title = '"'.$DBG->getCaption().'"';
		if ($DBG->isManyRowsSaveMode())
			$title .= ' +'."\n".'"<span id=\''.$varName.'_notsavedrows\'></span>"';	

        $x .=    '  title: '.$title.','.NL
				.'  store: '. $storeName .','.NL
				.'  applyTo: "'.$varName . '",'.NL
                .'  loadMask: true,'
				.'  sm: new Ext.grid.RowSelectionModel({ singleSelect: true'
				.($DBG->isManyRowsSaveMode() ? '' :
						', '.NL.'      listeners: { beforerowselect: dbgBeforeRowSelect}')
				.'   }),'.NL
				.'  frame: true,'.NL
				.'  height:'.$DBG->getHeight().','.NL
				.'  width:'.$DBG->getWidth().','.NL;

		if (!$DBG->isReadOnly()){
            $x .=    '  autoEncode: true, '.NL
                    .'  listeners: {afteredit : grdOnAfterEdit_'.$varName.'},'.NL;
			$ehtAR = mxl_widget_dbgrid::$ehtAppendRow;
			$ehtDR = mxl_widget_dbgrid::$ehtDeleteRow;
			$ehtRD = mxl_widget_dbgrid::$ehtRefreshData;
			$ehtSD = mxl_widget_dbgrid::$ehtSaveData;
			
			$refreshQt = mxl_cfg_messages::$widgets_dbgrid_tools_qtip__refresh_data;
			$appendQt  = mxl_cfg_messages::$widgets_dbgrid_tools_qtip__append_row;
			$deleteQt  = mxl_cfg_messages::$widgets_dbgrid_tools_qtip__delete_row;
			$saveQt    = mxl_cfg_messages::$widgets_dbgrid_tools_qtip__save_row;
			$x .=    '  tools:[{id:"refresh", qtip: "'.$refreshQt.'", handler: '
						.$WDBG->prepareEventHandler($ehtRD, 'dbgRefreshData_'.$nameWidget)
						.', scope:'.$varName.'},'.NL
					.'         {id:"plus",    qtip: "'.$appendQt.'", handler: '
						.$WDBG->prepareEventHandler($ehtAR, 'dbgAppendRow_'.$nameWidget)
						.', scope:'.$varName.'},'.NL
					.'         {id:"minus",   qtip: "'.$deleteQt.'", handler: '
						.$WDBG->prepareEventHandler($ehtDR, 'dbgDeleteRow_'.$nameWidget)
						.', scope:'.$varName.' },'.NL
					.'         {id:"save",    qtip: "'.$saveQt.'", handler: '
						.$WDBG->prepareEventHandler($ehtSD, 'dbgSaveRow_'.$nameWidget)
						.', scope:'.$varName.' }'.NL
					.'   ],'.NL 
					.'  clicksToEdit: '.$DBG->getClicksToEdit().','.NL;
		};

		$x .= '  columns: ['.NL;
		foreach ($DBG->getListFields() as $FI) {
			$edt_step = 0;
			$ftype = '';
			$fcapt = '';
			if ($FI->getDataType() == 'edatetime')
				$edt_step++;
    		for ($i = 0; $i <= $edt_step; $i++ ) {				
				if ($edt_step) 
					if ($FI->getDataType() == 'edatetime'){
						if ($i == 0) {
							$ftype = '_date';
							$fcapt = ' (D)';
						} elseif ($i == 1) {
							$ftype = '_time';
							$fcapt = ' (T)';
						}	
					}
        		if ($FI->getAttribs()->isCheck() && $FI->getDataType() == 'int'){
        			$hasCheckColumn = true;
        			
        			$befX .= 'var '.$DBG->getName().'_'.$FI->getName()
        					.'_checkColumn = new Ext.ux.grid.CheckColumnMxl({'.NL
        					.'  header: "'.$FI->getCaption().$fcapt.'",'.NL
        					.'  dataIndex: "'.$FI->getName().$ftype.'",'.NL
        					.'  width: '.$FI->getWidth() * 6
                            .($DBG->isReadOnly()||$FI->getAttribs()->isRO()? ','.NL.' readonly: true':'')
        					.'});'.NL;
        			$x .= $DBG->getName().'_'.$FI->getName().'_checkColumn, ';
        			$checkColumns .= $DBG->getName().'_'.$FI->getName().'_checkColumn, ';
        		} else { 		
					$x .= '   {header: "'.$FI->getCaption().$fcapt.'", dataIndex: "'
							.$FI->getName().$ftype.'"';
					$x .= ', width: '.$FI->getWidth() * 6;
        				
					if (!$DBG->isReadOnly() && ($FI->getName() != $DBG->getPrimKey())
                            && ( $FI->getDataType() != 'datetime')
							&& (!$FI->getAttribs()->isRO()) ){
					
						$x .= ', editor: edit_'.$DBG->getName().'_'.$FI->getName().$ftype;
        					

					}
    				if ($add_combo_renderer && $FI->getDataType() == 'string'
							&& $FI->getCfgComboName() && $FI->getAttribs()->isENUM())
						$x .= ', renderer: Ext.util.Format.comboRenderer('
								.'edit_'.$DBG->getName().'_'.$FI->getName().')';

                    if ($add_date_renderer && $i == 0 && $FI->getDataType() == 'edatetime'){
						$x .= ', renderer: Ext.util.Format.dateRenderer("'.$FI->getFormatDate().'")';
					}
                    
                    if ($add_date_renderer && $i == 0 && $FI->getDataType() == 'datetime'){
						$x .= ', renderer: Ext.util.Format.dateRenderer("'.$FI->getFormatDate()
                                .' '.$FI->getFormatTime().'")';
					}

                    if ($add_date_renderer && $FI->getDataType() == 'date'){
						$x .= ', renderer: Ext.util.Format.dateRenderer("'.$FI->getFormatDate().'")';
					}
					
					if (($FI->getDataType() == 'float')||($FI->getDataType() == 'int')){
						$x .= ', align: "right" ';
						if	($FI->getFormatNumber() != '')
							$x .= ', renderer: Ext.util.Format.numberRenderer("'.$FI->getFormatNumber().'")';
					}
										
					if ($DBG->isTotalsFooterMode()){
						$TFI = $DBG->getTotalFooterByFieldName($FI->getName());
				
    					if ($TFI) {
	    					$x .= ', summaryType: "'.$TFI->getType().'"';
    					
    						if ($TFI->getHint() != '' || $TFI->getCaption() != '')
								$x .= ', summaryRenderer: sumRenderer_'.$varName.'_'.$FI->getName();
	    				}
					}
        				
					if (($FI->getName() == $DBG->getPrimKey()) || $FI->getAttribs()->isRO())
						$x .= ', readOnly: true';
        					
					if ($FI->getAttribs()->isHD())
						$x .= ', hidden: true';
        					
					$x .= ', sortable: true},'.NL;
        		}
    		}
		}
		$x = substr($x, 0, strlen($x) - 2).NL;
		$x .=    '  ]'.NL;
		//переменная, которая хранит замещение события по нажатию кнопки обновить на панели пагинации
        $reorderRefreshEvn = '';
		if ($DBG->isPagingMode()){
            //если на кнопку обновления грида назначено другое событие, назначим его
            //кнопке обновления пагинации
            $evnName = $WDBG->prepareEventHandler($ehtRD, 'dbgRefreshData_'.$nameWidget);
            if ($evnName!='dbgRefreshData_'.$nameWidget)
            $reorderRefreshEvn = $varName.'.getBottomToolbar().refresh.handler = '.$evnName.';';
			$displayMsg = mxl_cfg_messages::$widgets_dbgrid_pagingbar_displayMsg;
			$emptyMsg   = mxl_cfg_messages::$widgets_dbgrid_pagingbar_emptyMsg;
			$x .=	'   ,bbar: new Ext.PagingToolbar({'.NL.
					'        pageSize: '.$DBG->getPageSize().','.NL.
					'        store: '.$storeName.','.NL.
					'        displayInfo: true,'.NL.
					'        displayMsg: "'.$displayMsg.'",'.NL.
					'        emptyMsg: "'.$emptyMsg.'"'.NL.
					'    })'.NL;
		}
		
		if ($DBG->isTotalsFooterMode()|| ($checkColumns != '')){
			$x .= ', plugins: [';
			
			$x1 = '';
			if ($DBG->isTotalsFooterMode())
				$x1 .= $varName.'_summary';
			if ($checkColumns != '')
				$x1 .= ($x1 != '' ? ',' : '').substr($checkColumns, 0, strlen($checkColumns) - 2);
				
			$x .= $x1.']'.NL;
		}
					
		if ($DBG->isShowGridHeader()) {
			$x .= ',tbar : [';
			$buf = '';
			if ($DBG->isTotalsFooterMode()){
				$buttonText    = mxl_cfg_messages::$widgets_dbgrid_totals_footer_mode_show_hide_button__text;
				$buttonTooltip = mxl_cfg_messages::$widgets_dbgrid_totals_footer_mode_show_hide_button__tooltip;
    			$buf .= '{'.NL.
    					'   text: "'.$buttonText.'",'.NL.
						'   tooltip: "'.$buttonTooltip.'",'.NL.
						'   handler: function(){'.$varName.'_summary.toggleSummary();}'.NL.
					    '}';
			}
			if ($DBG->isExportAble()) {
				$x = NL.'function post(url, params) {'.NL.
					'	var temp=document.createElement("form");'.NL.
					'	temp.action=url;'.NL.
					'	temp.method="post";'.NL.
					'	temp.style.display="none";'.NL.
					'	for(var x in params) {'.NL.
					'		var opt=document.createElement("textarea");'.NL.
					'		opt.name=x;'.NL.
					'		opt.value=params[x];'.NL.
					'		temp.appendChild(opt);'.NL.
					'	}'.NL.
					'	document.body.appendChild(temp);'.NL.
					'	temp.submit();'.NL.
					'	return temp;'.NL.
					'}'.NL.$x;
				$format = 'csv';
				$buf .= $buf == '' ? '' : '," | ",';
				$buttonText    = mxl_cfg_messages::$widgets_dbgrid_exportable_mode_export_button__text;
				$buttonTooltip = mxl_cfg_messages::$widgets_dbgrid_exportable_mode_export_button__tooltip.$format;
    			$title         = mxl_cfg_messages::$widgets_dbgrid_exportable_mode_not_saved_title;
    			$msg           = mxl_cfg_messages::$widgets_dbgrid_exportable_mode_not_saved_text;
				$buf .= '{'.NL. 
					'	text: "'.$buttonText.'",'.NL.
	    			'	tooltip: "'.$buttonTooltip.'",'.NL.
	    			'	handler: function(){'.NL.
	    			'		if ('.$storeName.'.getModifiedRecords().length > 0) {'.NL.
	    			'			Ext.Msg.show({'.NL.
	    			'				title: "'.$title.'",'.NL.
	    			'				buttons: Ext.MessageBox.OK,'.NL.
	    			'				msg:"'.$msg.'",'.NL.
	    			'				fn: function(btn){return;}'.NL.
	    			'			})'.NL.
	    			'		} else {'.NL.
					'			post("'.$url.'", {'.NL.
					'				action:   "export",'.NL.
					'				format:   "'.$format.'",'.NL.
					'				gridName: '.$storeName.'.baseParams["gridName"],'.NL.
					'				params:   '.$storeName.'.baseParams["params"]'.NL.
					'			})'.NL.
					'		}'.NL.
	  				'	}'.NL.
					'}';
			}
    		if ($DBG->isTotalsGridMode()) {
    			$buf .= $buf == '' ? '' : '," | ",';
				$buf .= '"<span id=\''.$varName.'_'.'totalspan'.'\'></span>"';
    		}
				
			$x .= $buf.']'.NL;
		}
		$x .= '  });'.NL;

        //если есть пагинация и кнопке грида refresh назначена собственная функция
        //назначим эту функицию кнопке refresh панели пагинации
        $x .= $reorderRefreshEvn;

		return $befX.$x;
	}
	
	/**
	 * Возвращает JS код для инициализации "строки итогов по гриду" в верхней
	 * панели грида tbar
	 * 
	 * @param string $gridName
	 * @param mxl_dict_dbgrid $DBG
	 * @return string
	 */
	public static function get_dbg_grid_initTotalStr($gridName, 
			mxl_dict_dbgrid $DBG){
		$total_str = $DBG->getTotalGridStr();
					
		$x =    'var total_str = "'.$total_str.'";'.NL.
				'var el = Ext.get("'.$gridName.'_'.'totalspan'.'").dom;'.NL.
				'if (el && total_str)'.NL.
				'	el.innerHTML = total_str;';
		return $x;
	}
	
	/**
	 * Возвращает JS код для обновления строки "итогов по гриду" в верхней 
	 * панели грида tbar
	 * 
	 * @param string $gridName
	 * @return string
	 */
	public static function get_dbg_grid_updateTotalStr1($gridName, $tab){
		return	$tab.'var total_str = Ext.util.JSON.decode(resp.responseText)'
						.'.total_str;'.NL.
				$tab.'var el = Ext.get("'.$gridName.'_totalspan").dom;'.NL.
				$tab.'if (el && total_str)'.NL.
				$tab.'  el.innerHTML = total_str;';
	}
	
	/**
	 * Метод возвращает переменную для редактирования строки грида.
	 * Вывод производится по частям в параметры функции.
	 * @param string $declarePartCommon - общая декларативная часть
	 * @param string $declarePartPers - общая персональная часть
	 * @param string $runPart - часть выполнения
	 * @param strin $nameWG - имя виджета грида
	 * @param mxl_dict_dbgrid $DBG - модель грида
	 * @param mxl_core_params $gridParams - динамические параметры грида, 
	 * 		сначала инициализируется ими, но потом можно править непосредственнно
	 * 		в storage для комбобоксов
	 * @param string $url - URL адрес для отправки запросов
	 * @param boolean $append_SID - использовать _SID в BaseParams
	 * @return boolean
	 */
	public static function getJS_dbg_EditRow($nameWG, mxl_dict_dbgrid $DBG, 
			mxl_core_params $gridParams, $url, $append_SID = false){

		$rec = 'var record_'.$nameWG.'= Ext.data.Record.create(['.NL;

		foreach ($DBG->getListFields() as $FI){
            $rFName = $FI->getName();
            $rFType = $FI->getDataType();
            if ($rFType == 'edatetime') {
                $rec .= '  {name:"'.$rFName.'_date'.', type:'.'date'  .'"},'.NL;
                $rec .= '  {name:"'.$rFName.'_time'.', type:'.'string'.'"},'.NL;
            } else {
        		$rec .= '  {name:"'.$rFName.', type:'.$rFType.'"},'.NL;
            }
		}
		$rec = substr($rec, 0, strlen($rec) - 2).NL;
		$rec .= '   ]);'.NL;
		return $rec;
	}

    private static function getFuncText_onDbgSpecialkey($gridName){
        $x = 'function on_'.$gridName.'_specialkey(f, e) {'.NL
            .'  if (e.getKey() == '.'Ext.EventObject.ENTER) {'.NL
            .'    e.keyCode = Ext.EventObject.TAB;'.NL
            .'    dbg_gbg28.fireEvent("keypress", e);'.NL
            .'  }'.NL
            .'}'.NL;
        return $x;
    }

    /**
	 * Метод редакторы для полей грида по частям
	 * @param string $declarePartCommon - общая декларативная часть
	 * @param string $declarePartPers - общая персональная часть
	 * @param string $runPart - часть выполнения
	 * @param strin $nameWG - имя виджета грида
	 * @param mxl_dict_dbgrid $DBG - модель грида
	 * @param mxl_core_params $gridParams - динамические параметры грида,
	 * 		сначала инициализируется ими, но потом можно править непосредственнно
	 * 		в storage для комбобоксов
	 * @param string $url - URL адрес для отправки запросов
	 * @param boolean $append_SID - использовать _SID в BaseParams
	 * @return boolean
	 */
	public static function getJS_dbg_Editors(&$declarePartCommon,
			&$declarePartPers, &$runPart, $nameWG, mxl_dict_dbgrid $DBG,
			mxl_core_params $gridParams, $url, $gridAutoload, $append_SID = false){

		$storage 		= '';
		$listeners 		= '';
		$listeners_desc = '';
		$eVars          = '';
        
        $rpp = '';
        $rpp .= 'store_dbg_'.$nameWG.'.allready_first_load = false;'.NL;


        $editListeners  = array();

		if ($DBG->isNextColOnEnter() && !$DBG->isReadOnly()) {
			$eVars .= NL.mxl_widget_extjs::getFuncText_onDbgSpecialkey($DBG->getName());
			$editListeners = array('specialkey' => 'on_'.$DBG->getName().'_specialkey');
		}

        $hasNLE = false;
		foreach ($DBG->getListFields() as $FI){
            $eName    = 'edit_'.$DBG->getName().'_'.$FI->getName();
            switch ($FI->getDataType()) {

            case 'int':
                if (!$FI->getAttribs()->isCheck()&&!$DBG->isReadOnly()) {
                    $eVars .= mxl_widget_extjs::getNew_form_NumberField(
                            $eName, 0, $editListeners).NL;
                }
                break;
            case 'float':
                if (!$DBG->isReadOnly())
                    $eVars .= mxl_widget_extjs::getNew_form_NumberField(
                            $eName, $FI->getDataLength(), $editListeners).NL;
                break;
			case 'date':
                if (!$DBG->isReadOnly())
                    $eVars .= mxl_widget_extjs::getNew_form_DateField($eName,
                            $FI->getFormatDate(),'','','','',$editListeners);
				break;
			case 'edatetime':
                if (!$DBG->isReadOnly()){
                    $eVars .= mxl_widget_extjs::getNew_form_DateField($eName.'_'.'date',
                            $FI->getFormatDate(), 'true', '', 'false', '"32%"',
                            $editListeners).NL;
    				$eVars .= mxl_widget_extjs::getNew_form_TimeField($eName.'_'.'time',
                            $FI->getFormatTime(), '', '60', 'false', '"32%"',
                            $editListeners).NL;
                }
				break;
			case 'boolean':
				break;
            case 'string':
				if (!$FI->getCfgComboName() && !$DBG->isReadOnly()) {
					$eVars .= mxl_widget_extjs::getNew_form_TextField(
    						$eName, $FI->getDataLength(), $FI->getMaskRe(),
                            $editListeners).NL;
				} else {
                    if (($DBG->isReadOnly() && $FI->getAttribs()->isEnum()) ||
                            !$DBG->isReadOnly() ){
                        $eVars  .= 'var '.$eName.' = ';

                        $stor = $list = $list_desc = '';
                        $cbxW = new mxl_widget_combobox($eName,
                                $FI->getCfgComboName(),	'', $gridParams);
        				$cbx  = $cbxW->getLinkCFG();
            			$autoload = $FI->getAttribs()->isEnum() && !$cbx->isInputTextMode();
                		$cbx_js = $cbxW->getJSCodeGridVers($stor, $list, $list_desc,
                    			($FI->getAttribs()->isEnum()== false ?
                        				$FI->getRelIdFieldFromRel():
                            			$FI->getName()),
                                'dbg_'.$nameWG, $FI->getName(), $eName,
    							$autoload, false, $FI->getListWidth());

        				$eVars      .= $cbx_js.NL;
                        if ($FI->getAttribs()->isEnum()){
                            $hasNLE = true;
                            //$nameWG
                            $tv = 'store_dbg_'.$nameWG.'.need_loaded_elements';
                            $rpp  .=  'if ('.$tv.'=== undefined){ '.NL
                                    . '  '.$tv.' = [];'.NL
                                    . '}'.NL;
                            $rpp  .= $tv.'[\''.$eName.'\'] = false;'.NL;
                            $rpp  .= $eName.'.store.on("load", function(store, records, options) {'.NL
                                    . '  '.$tv.'[\''.$eName.'\'] = true;'.NL
                                    . '  if (store_dbg_'.$nameWG.'.allready_first_load!==true) {'.NL
                                    . '    mxl_check_and_load_grid_store(store_dbg_'.$nameWG.','.
                                            ($gridAutoload?'false':'true').');'.NL
                                    . '  }'.NL
                                    . '});'.NL;
                        }

            			if ($DBG->isNextColOnEnter())
                			$eVars .= $eName.'.on("specialkey", on_'.$DBG->getName().'_specialkey);'.NL;
                        $storage 		.= NL.$stor;
    					$listeners 		.= NL.$list;
        				$listeners_desc .= NL.$list_desc;
                    }
				}
				break;
            }
        }
        if (!$hasNLE){
            $rpp .= 'mxl_check_and_load_grid_store(store_dbg_'.$nameWG.','.($gridAutoload?'false':'true').');'.NL.NL;
        }
        $declarePartPers = $storage.$eVars.NL;
        $runPart         = $listeners_desc.$listeners.NL.$rpp;
        return true;
	}

/*
 * ============================================================================
 * ===================  ФУНКЦИИ EXTJS ДЛЯ ПОДДЕРЖКИ КОМБО  ==================== 
 * ============================================================================
 */	
	public static function getFuncText_cbxOnLoad($storageName, $comboName, 
			mxl_widget_combobox $wCBX){
		$x =     'function strgCbxOnLoad_'.$storageName.'(stor, rec, optn){'.NL;
		if ($wCBX->getStartValue()){
			$x .='  '.$comboName.'.hiddenValue ='.$wCBX->getStartValue().';'.NL;
			$x .='  '.$comboName.'.originalValue ='.$wCBX->getStartValue().';'.NL;
			$x .='  '.$comboName.'.setValue('.$wCBX->getStartValue().');'.NL;
		}
		$x .=    '};';
		return $x;
	}
	/**
	 * Метод возвращает JS код хранилища комбобокса.
	 * @param string $varName - имя комбобокса
	 * @param mxl_dict_combobox $CBX - модель комбобокса
	 * @param string $baseParams - код JS, базоыве параметры
	 * @param string $url - URL адресс отправки запросов для комбобокса
	 * @param string $autoload - загружать данные автоматически
	 * @return string
	 */
	public static function get_combo_data_Store($varName, mxl_dict_combobox $CBX,
			$baseParams, $url, $autoload = false){
		$valFld   = $CBX->getValueField();
		$dispFld  = $CBX->getDisplayField();

		$x = $varName.'= new Ext.data.Store({'.NL
				.'  reader: new Ext.data.JsonReader({'.NL
				.'    id:"'.$varName.'",'.NL
				.'    root: "rows"'.NL
				.'    },'.NL
				.'    ['.NL
				.'    {name: "'.$valFld.'", type: "string", mapping:"'.$valFld.'"},'.NL
				.'    {name: "'.$dispFld.'", type: "string", mapping:"'.$dispFld.'"}'.NL
				.'    ]),'.NL
				.'  proxy: new Ext.data.HttpProxy({'.NL
				.'    url: "'.$url.'",'.NL
				.'    method: "POST"'.NL
				.'    }),'.NL
				. ($autoload ? '  autoLoad: true,'.NL : '  autoLoad: false,')
				.'  baseParams:'.$baseParams .NL
				.'  });'.NL;
		return $x;
	}
	
	/**
	 * Метод для получения JS кода для комбобокса.
	 * @param string $comboName - имя комбобокса
	 * @param string $storeName - имя хранилища комбобокса
	 * @param mxl_dict_combobox $CBX - модель комбобокса
	 * @param string $hiddenName - id элемента в который будет осуществлятся вывод
	 * @param string $gridMode - режим грида
	 * @param int $listWidth - ширина списка комбобокса, если 0 то остается по умолчанию
	 * @return string 
	 */
	public static function get_form_ComboBox($comboName, $storeName, 
			mxl_dict_combobox $CBX,	$hiddenName = '', $gridMode = false,
			$listWidth = 0){
		$valFld   = $CBX->getValueField();
		$dispFld  = $CBX->getDisplayField();
		$emptyTxt = $CBX->getEmptyText();
		
		if (! $gridMode)
			$hidName  = $hiddenName ? $hiddenName : $valFld;
		
		$x = $comboName
				. ($CBX->isClearedMode() ? 
						' = new Ext.form.ClearableComboBox({':
						' = new Ext.form.ComboBox({').NL
				. '  store: '. $storeName .','.NL
				. '  valueField:"'.$valFld.'",'.NL
				. '  displayField:"'.$dispFld.'",'.NL.
				($CBX->isInputTextMode()?
					  '  mode: "local",'.NL
					. '  typeAhead: true,'.NL
					. '  editable: true,'.NL
					. '  minChars: 0,'.NL 
					. '  forceSelection: false,'.NL
					. '  selectOnFocus: false,'.NL
				: 
				  	  '  mode: "remote",'.NL
					. '  typeAhead: true,'.NL
					. '  editable: false,'.NL
					. '  forceSelection: true,'.NL
					. '  selectOnFocus: true,'.NL
				)
				. ($listWidth > 0 ? '  listWidth: '.$listWidth.','.NL : '')
				. '  triggerAction: "all",'.NL
				. '  emptyText:"'.$emptyTxt.'",'.NL
				. (! $gridMode ? '  hiddenName:"'. $hidName .'",'.NL : '')
				
				. (  $gridMode ? '  lazyRender: true'.NL : 
					'  applyTo: "'.$comboName . '"'.NL )
				. '  });'.NL;
		return $x;
	}
	
	/**
	 * Метод для получения JS кода для комбобокса модификация поиска.
	 * @param string $comboName - имя комбобокса
	 * @param string $storeName - имя хранилища комбобокса
	 * @param mxl_dict_combobox $CBX - модель комбобокса
	 * @param string $hiddenName - id элемента в который будет осуществлятся вывод
	 * @return string 
	 */
	public static function get_form_ComboBox_Seach($comboName, $storeName, 
			mxl_dict_combobox $CBX,	$hiddenName = ''){
		$valFld   = $CBX->getValueField();
		$dispFld  = $CBX->getDisplayField();
		$emptyTxt = $CBX->getEmptyText();
		
		$hidName  = $hiddenName ? $hiddenName : $valFld;		
		
		$x = $comboName.' = new Ext.form.ComboBox({'
				. '  store: '. $storeName .','.NL
				. '  valueField:"'.$valFld.'",'.NL
				. '  displayField:"'.$dispFld.'",'.NL
				. '  typeAhead: true,'.NL
				. '  loadingText: "Searching...",'.NL
				. '  queryParam : "query_seach", '.NL
        		. '  hideTrigger:true,'.NL
				. '  mode: "remote",'.NL
				. '  emptyText:"'.$emptyTxt.'",'.NL
				. '  hiddenName:"'. $hidName .'",'.NL
				. '  applyTo: "'.$comboName . '"'.NL
				. '  });'.NL;
		return $x;
	}
	
	/**
	 * Возвращает JS код для события "после выбора значения". Необходим при работе 
	 * со связанными полями в гриде.
	 * @param string $funcNamePref - префикс функции
	 * @param string $dbgridName - имя грида для которого стоится комбо
	 * @param string $valFld - поле со значением
	 * @param string $editName - имя редактора поля
	 * @return string 
	 */
	public static function getFuncText_cbxOnSelect($funcNamePref, $dbgridName,
			$valFld, $editName){
		$x = 'function onSelect_'.$funcNamePref.'(combo, record, index)'.NL
				. '{'.NL
				. '  var sm = '.$dbgridName.'.getSelectionModel();'.NL
				. '  var sel = sm.getSelected();'.NL
				. '  sel.set("'.$valFld.'", '.$editName.'.getValue());'.NL
				//. '  sel.set("'.$valFld.'", record.get("'.$valFld.'"));'.NL
				. '}'.NL;
		return $x;
	}
/*
 * ============================================================================
 * ================== ФУНКЦИИ EXTJS ДЛЯ ПОДДЕРЖКИ "СПИСКА"  =================== 
 * ============================================================================
 */	
	public static function get_list_data_Store($varName, mxl_dict_list $LST,
			$baseParams, $url, $autoload = false){
		$valFld   = $LST->getValueField();
		$dispFld  = $LST->getDisplayField();

		$x = $varName.'= new Ext.data.Store({'.NL
				.'  reader: new Ext.data.JsonReader({'.NL
				.'    id:"'.$varName.'",'.NL
				.'    root: "rows"'.NL
				.'    },'.NL
				.'    ['.NL
				.'    {name: "'.$valFld.'", type: "string", mapping:"'.$valFld.'"},'.NL
				.'    {name: "'.$dispFld.'", type: "string", mapping:"'.$dispFld.'"}'.NL
				.'    ]),'.NL
				.'  proxy: new Ext.data.HttpProxy({'.NL
				.'    url: "'.$url.'",'.NL
				.'    method: "POST"'.NL
				.'    }),'.NL
				. ($autoload ? '  autoLoad: true,'.NL : '')
				.'  baseParams:'.$baseParams .NL
				.'  });'.NL;
		return $x;
	}

	/**
	 * Метод для получения JS кода для "Списка" с множественным выбором.
	 */
	public static function get_form_List_Multiselect($listName, $storeName, 
			$panelName,	mxl_dict_list $LST){
		
		$x = $panelName.' = new Ext.form.FormPanel({'.NL
        		.($LST->getTitle() ? '  title: \''.$LST->getTitle().'\','.NL : '')
        		.'  width: '.$LST->getCommonWidth().','.NL
        		.'  bodyStyle: \'padding:10px;\','.NL
        		.'  renderTo: \''.$listName.'\','.NL
        		.'  items:[{'.NL
        		.'    xtype: \'multiselect\','.NL
        		.($LST->getFieldLabel() ? 
        			'    fieldLabel: \''.$LST->getFieldLabel().'\'' : 
        			'    hideLabel : true').','.NL
        		.'    name: \''.$listName.'\','.NL
        		.'    width: '.$LST->getElementWidth().','.NL
        		.'    height: '.$LST->getHeight().','.NL
        		.'    store: '.$storeName.','.NL
        		.'    displayField: \''.$LST->getDisplayField().'\','
        		.'    valueField: \''.$LST->getValueField().'\','
        		.'    allowBlank:false,'.NL
        		.($LST->getClearButton() ? 
        			'    tbar:[{'.NL.
        			'      text: \'clear\','.NL.
        			'      handler: function(){'.NL.
        			'        '.$panelName.'.getForm().findField(\''.$listName.'\').reset();'.NL.
        			'      }'.NL.
        			'    }],'.NL:
        			'')
        		.'    ddReorder: true'.NL
        		.'  }]'.NL 
        		.'});';
		return $x;
	}
	
	/**
	 * Метод для получения JS кода для "Списка" с двумя полями, в одном поле
	 * доступные для выбора значения во втором оторбанные.
	 */
	public static function get_form_List_Itemselector($listName, $storeName, 
			$panelName,	mxl_dict_list $LST){
		$x = $storeName.'_res = new Ext.data.ArrayStore({'.NL
				.'  data: [],'.NL
				.'  fields: [\''.$LST->getValueField().'\',\''.$LST->getValueField().'\'],'.NL
				.'  sortInfo: {'.NL
				.'    field: \''.$LST->getValueField().'\','.NL
				.'    direction: \'ASC\''.NL
				.'  }'.NL
				.'});'.NL;
		$x .= $panelName.' = new Ext.form.FormPanel({'.NL
        		.($LST->getTitle() ? '  title: \''.$LST->getTitle().'\','.NL : '')
        		.'  width: '.$LST->getCommonWidth().','.NL
        		.'  bodyStyle: \'padding:10px;\','.NL
        		.'  renderTo: \''.$listName.'\','.NL
        		.'  items:[{'.NL
        		.'    xtype: \'itemselector\','.NL
        		.($LST->getFieldLabel() ? 
        			'    fieldLabel: \''.$LST->getFieldLabel().'\'' : 
        			'    hideLabel : true').','.NL
        		.'    name: \''.$listName.'\','.NL
	        	.'    imagePath: \'./libs/extjs/plugins/ux/images/\','.NL
	        	.'    multiselects: [{'.NL
	        	.'      width: '.$LST->getElementWidth().','.NL
        		.'      height: '.$LST->getHeight().','.NL
        		.'      store: '.$storeName.','.NL
        		.'      displayField: \''.$LST->getDisplayField().'\','.NL
        		.'      valueField: \''.$LST->getValueField().'\''.NL
        		.'    },{'.NL
        		.'      width: '.$LST->getElementWidth().','.NL
        		.'      height: '.$LST->getHeight().','.NL
        		.'      store: '.$storeName.'_res, '.NL
        		.'      displayField: \''.$LST->getDisplayField().'\','.NL
        		.'      valueField: \''.$LST->getValueField().'\''.NL
                .($LST->getClearButton() ?
                	','.NL. 
        			'    tbar:[{'.NL.
        			'      text: \'clear\','.NL.
        			'      handler: function(){'.NL.
        			'        '.$panelName.'.getForm().findField(\''.$listName.'\').reset();'.NL.
        			'      }'.NL.
        			'    }]'.NL:
        			'')
				.'    }]'.NL 
                .'  }]'.NL 
				.'});';
		return $x;
	}
/* 
 * =============================================================================
 *                      Прочие функции 
 * =============================================================================
 */
	/**
	 * Функция инициализирует обработчик события "перед закрытием страницы"
	 * @return string
	 */
	public static function getInitHtmpPageOnBeforeUnload(){
		$x =    'var root = window.addEventListener || window.attachEvent ?'.NL.
				'    window : '.NL.
				'    document.addEventListener ? document : null;'.NL.
				'root.onbeforeunload = mxl_onbeforeunload;'.NL.NL;
		return $x;
	}
	
	/**
	 * Возвращает текст обработчика события "перед закрытием страницы".
	 * Обработчик проверяет гриды в находящиеся  режиме "сохраниние множества 
	 * строк" и выводит предупреждение если есть не сохраненные строки в гридах. 
	 * @param mxl_widget_widgets $WGTS
	 * @return string
	 */
	public static function getFuncText_mxl_onbeforeunload(mxl_widget_widgets $WGTS){
		$x =    'function mxl_onbeforeunload(){'.NL.
				'  var err_str = "";'.NL;
		$rowText  = mxl_cfg_messages::$htmlpage_beforeunload_grids_notsave__one_row_text;
		$rowsText = mxl_cfg_messages::$htmlpage_beforeunload_grids_notsave__many_rows_text;
		$errMess  = mxl_cfg_messages::$htmlpage_beforeunload_grids_notsave__message;
		if (strpos($errMess, '#VTINS') !== false)
			$errMess = str_replace('#VTINS', '" + '.NL.'      err_str + "', $errMess);
		
		foreach($WGTS->getListWidget() as $WGS)
			if (($WGS instanceof mxl_widget_dbgrid) 
					&&($WGS->getLinkCfg()->isManyRowsSaveMode())){
		 		$nm1 = 'store_dbg_'.$WGS->getName();
		 		$nm2 = $WGS->getLinkCFG()->getCaption();
				
		 		$x .=   '  if ('.$nm1.'.getModifiedRecords().length > 0){'.NL.
		 				'    var not_saved_rows = '.$nm1.'.getModifiedRecords().length;'.NL.
		 				'    err_str += "    \"'.$nm2.'\" - " + not_saved_rows + '.NL.
		 				'      (not_saved_rows == 1 ? " '.$rowText.'" : " '.$rowsText.'");'.NL.
		 				'  }'.NL; 
			}
			
		$x .=   '  if (err_str)'.NL.
  				'    return "'.$errMess.'\n";'.NL.
				'};'.NL;
		return $x;
	}
	
	/**
	 * Возвращает текст функции для обработки ответа сервера содержащего ошибки.
	 * Возможны два типа ошибок: не поймайное исключение и ошибки валидации.
	 * @return string
	 */
	public static function getFuncText_mxl_showErrorByResponseText(){
		$x =    'function mxl_showErrorByResponseText(responseText, baseMsg){'.NL.
				'  var validate = Ext.util.JSON.decode(responseText).validate;'.NL.
				'  var error = Ext.util.JSON.decode(responseText).error;'.NL.
				'  if (validate){'.NL.
				'    Ext.Msg.alert("'.mxl_cfg_messages::$types_error.
						'", baseMsg + "<br><br>'.mxl_cfg_messages::$types_validate.
						':<br>"+ validate);'.NL.
				'  } else if (error){'.NL.
				'    Ext.Msg.alert("'.mxl_cfg_messages::$types_error.
						'", baseMsg + "<br><br>'.mxl_cfg_messages::$types_error.
						':<br>" + error);'.NL.
				'  } else {'.NL.
				'    Ext.Msg.alert("'.mxl_cfg_messages::$types_error.
						'", baseMsg);'.NL.
				'  }'.NL.
				'}'.NL;
		return $x;
	}
}
?>